<?php

if(isset($_REQUEST['stats'])) {
	$anz = 0;
	$size = 0;
	$ids = @(array)Shop::Container()->getCache()->getKeysByTag('supercache');
	foreach($ids as $id)
	{
		$x = Shop::Container()->getCache()->get($id);
		if($x)
		{
			$anz++;
			$size += mb_strlen($x);
		}
	}
	$base = log($size, 1024);
	$suffixes = array('', 'K', 'M', 'G', 'T');   

	$sizeFormatted = round(pow(1024, $base - floor($base)), 1) .' '. $suffixes[floor($base)]."B";

	if($anz == 0) $sizeFormatted = '-';

	$files = glob(PFAD_ROOT.'plugins/km_supercache/cache/*'); //get all file names
	$fileSize = 0; 
	foreach($files as $file)
	{
		if(is_file($file))
			$fileSize += filesize($file);
	}
	$base = log($fileSize, 1024);
	if($fileSize == 0) $sizeFormattedFile = '-';
	else
	$sizeFormattedFile = round(pow(1024, $base - floor($base)), 1) .' '. $suffixes[floor($base)]."B";

	$return = array(
		'anz' => $anz,
		'sizeCache' => $sizeFormatted,
		'sizeFiles' => $sizeFormattedFile
	);
	
	header('Content-Type: application/json');
	http_response_code(200);
	die(json_encode($return));
}
?>
<div class="alert alert-info">
	Willst du einen direkten Vergleich?
	Dann prüfen deinen "Time to First Byte" unter <a href="https://www.bytecheck.com/" target="_blank">https://www.bytecheck.com/</a>.<br>
	Der Punkt "" zeigt dir die Antwortzeit deines Servers. Messe ruhig 3-4mal um einen Durchschnittswert zu erhalten.<br>
	Aktiviere/Deaktiviere einfach das Plugin um Vergleichswerte zu erhalten, beachte aber dass immer der erste Aufruf (egal ob der Supercache an ist oder nicht) am längsten dauert da hier gar nichts im Cache ist und sogar der "normale" JTL Cache nicht greift.<br><br>
	Die Einstellungen des Supercaches sind im Standard ideal gesetzt - ändere nur was du bewusst anpassen willst - wo es nicht sinnvoll ist schließen wir automatisch aus: z.B. im Warenkorb oder wenn man eingeloggt ist.
</div>
<?php
if(isset($_POST['clearSuperCache']))
{
	//JTL Cache leeren
	Shop::Container()->getCache()->flushTags(['supercache']);
	
	//Dateicache leeren
	$files = glob(PFAD_ROOT.'plugins/km_supercache/cache/*'); //get all file names
	foreach($files as $file)
	{
		if(is_file($file))
			unlink($file);
	}
	
} 

if(isset($_POST['clearSuperCacheByURL']))
{
	$url = parse_url($_POST['clearUrl']);
	if($url && isset($url['path']))
	{
		Shop::Cache()->flushTags(str_replace('/','__',$url['path']));
		echo '<div class="alert alert-success"><i class="fa fa-info-circle"></i> Cache der URL <strong>'.$url['path'].'</strong> wurde erfolgreich geleert.</div>';
	}	
}
?>
<form method="post" action="" class="navbar-form">
<div class="panel panel-default first">
	<div class="panel-heading"><h3 class="panel-title">Cache nach URL leeren</h3></div>
	<div class="panel-body">
		<div class="form-group form-row align-items-center">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">Einzelne URL erneuern</label>
			</div>
			<div class="col-md-5">
				<input type="text" class="form-control" value="" id="clearUrl" name="clearUrl">
			</div>
		</div>
	</div>
	<div class="panel-body">
		<div class="form-group form-row align-items-center">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">&nbsp;</label>
			</div>
			<div class="col-md-3" style="padding: 10px 0;">
				<button name="clearSuperCacheByURL" type="submit" value="Cache leeren" class="btn btn-primary"><i class="fa fa-save"></i> Cache nach URL leeren</button>
			</div>
		</div>
	</div>
</div>
</form>
<br>

<div class="panel panel-default">
	<div class="panel-heading"><h3 class="panel-title">Statistik</h3></div>
	<div class="panel-body">
		<div class="form-group form-row align-items-center">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">Gecachte Seiten</label>
			</div>
			<div class="col-md-3">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_anz">
			</div>	
		</div>
		<div class="form-group form-row align-items-center">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">Gr&ouml;&szlig;e Standardcache</label>
			</div>
			<div class="col-md-3">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_sizeFormatted">
			</div>	
		</div>	
		<div class="form-group form-row align-items-center">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">Gr&ouml;&szlig;e Dateicache</label>
			</div>
			<div class="col-md-3">
				<input type="text" readonly="" class="form-control" value="Wird geladen ..." id="supercache_sizeFormattedFile">
			</div>
		</div>
	</div>
	<div class="panel-body">
		<div class="input-group">
			<div class="col-md-3">
				<label for="km_snackys_sale_prozent">&nbsp;</label>
			</div>
			<form method="post" action="" class="col-md-3" style="padding: 10px 0;">
				<button name="clearSuperCache" type="submit" value="Cache leeren" class="btn btn-primary"><i class="fa fa-save"></i> gesamten Cache leeren</button>
			</form>
		</div>
	</div>
</div>
<script type="text/javascript">
//Load Stats async, because of some big data will take long
var pluginUrl = '?stats=<?php echo time(); ?>';

function loadSupercacheStats()
{	
	var data = {io: '{"name": "km_live_update","params": []}'};
	$.ajax({
		url: pluginUrl,
		method: "GET"
	}).done(function (stats) {
		try
		{
			if(!stats)
				throw "dataError";
			$('#supercache_anz').val(stats.anz);
			$('#supercache_sizeFormatted').val(stats.sizeCache);
			$('#supercache_sizeFormattedFile').val(stats.sizeFiles);
		} catch (e) {
			$('#supercache_anz,#supercache_sizeFormatted,#supercache_sizeFormattedFile').val('Fehler beim Laden');
		}
	});
}
loadSupercacheStats();

//Beim Klick auf cookie, diesen übernehmen
$(document).ready(function(){
	$('#km_supercache_cookie_dummmy').dblclick(function(e)
	{
		var val = $(this).val();
		var found = false;
		var free = false;
		for(var i=1;i<=30;i++)
		{
			if($('#km_supercache_cookie'+i).val() == "" && free == false)
				free = i;
			if($('#km_supercache_cookie'+i).val() == val && found == false)
				found = true;
			
			if(free != false && found != false)
				i= 31;
		}
		if(!found && free)
			$('#km_supercache_cookie'+free).val(val)
	});
});
</script>